;
;
;
;    Resea (api/assembly_x86.asm)
;    Mafice <mafice@mflabo.net>
;
;
;

[bits 32]


API_putchar        equ  901
API_out            equ  111
API_in             equ  121
API_setISR         equ  201
API_waitInterrupt  equ  202


;
;  Function: asm_putchar
;
;    一文字表示する
;
;  Parameters:
;
;    ch -  表示する文字
;
;  Returns:
;
;    なし
;
;

global asm_putchar
asm_putchar:

mov eax, API_putchar
mov edi, [esp+4]
	
int 0x70
ret




;
;  Function: asm_out8
;
;    OUT命令を実行する
;
;  Parameters:
;
;    dest -  送信先
;    data -  データ
;
;  Returns:
;
;    なし
;
;

global asm_out8
asm_out8:

mov eax, API_out
mov edi, [esp+4]
mov ebx, [esp+8]
mov ecx, 8

int 0x70
ret




;
;  Function: asm_in8
;
;    IN命令を実行する
;
;  Parameters:
;
;    src -  受信元
;
;  Returns:
;
;    受信したデータ
;
;

global asm_in8
asm_in8:

mov eax, API_in
mov esi, [esp+4]
mov ecx, 8

int 0x70
ret




;
;  Function: asm_waitInterrupt
;
;    割り込みを待つ
;
;  Parameters:
;
;    irq -  割り込み要求の番号
;
;  Returns:
;
;    なし
;
;

global asm_waitInterrupt
asm_waitInterrupt:

mov eax, API_waitInterrupt
mov esi, [esp+4]

int 0x70
ret




;
;  Function: asm_setISR
;
;    割り込みハンドラを登録する
;
;  Parameters:
;
;    irq    -  割り込み要求の番号
;    offset -  ハンドラの先頭アドレス
;
;  Returns:
;
;    登録に成功した場合はtrue、失敗した場合はfalseを返します。
;
;

global asm_setISR
asm_setISR:

mov eax, API_setISR
mov esi, [esp+4]
mov edx, [esp+8]

int 0x70
ret

