/*
 *
 *
 *    Resea (x86_64/string.c)
 *    Mafice <mafice@mflabo.net>
 *
 *
 */

#include "kernel.h"



/*
*
*  Function: memcpy
*
*    データをコピーする
*
*  Parameters:
*
*    to    - コピー先
*    from  - コピー元
*    size  - コピーする量 (バイト単位)
*
*  Returns:
*
*    なし
*
*/

void memcpy (void *to, void *from, size_t size){

 index_t  i;

  for(i=0; i < size; i++)
    *((char *) to+i) = *((char *) from+i);

  return;
}




/*
*  Function: strlen
*
*    文字列の長さを調べる
*
*  Parameters:
*
*    str  - 文字列
*
*  Returns:
*
*    文字数
*
*/

size_t strlen (const char *str){

 index_t  i;

  for(i = 0; str[i] != 0; i++);

  return i;
}




/*
*  Function: strncmp
*
*    文字列を指定した文字数だけ比較する
*
*  Parameters:
*
*    str1  - 比較する文字列
*    str1  - 比較する文字列
*    len   - 比較する文字数
*
*  Returns:
*
*    文字列の先頭から指定医sた文字数までの文字列が等しい(内容が同じ)場合には0、等しくない場合は1を返します。
*
*/

int strncmp (const char *str1, const char *str2, size_t len){

 index_t  i;

  for(i=0; (str1[i] == str2[i]) && (i < len); i++);

  if(i == len)
    return 0;
  else
    return 1;
}




/*
*  Function: strcmp
*
*    文字列を比較する
*
*  Parameters:
*
*    str1  - 比較する文字列
*    str2  - 比較する文字列
*
*  Returns:
*
*    文字列が等しい(内容が同じ)場合には0、等しくない場合は1を返します。
*
*/

int strcmp (const char *str1, const char *str2){

 index_t  i;

  for(i=0; (str1[i] == str2[i]) && ((str1[i] != '\0') && ((str2[i] != '\0'))); i++);

  if(str1[i] == str2[i])
    return 0;
  else
    return 1;
}




/*
*  Function: strcpy
*
*    文字列をコピーする
*
*  Parameters:
*
*    str1  - コピー先
*    str2  - コピー元
*
*  Returns:
*
*    str1へのポインタ
*
*/

char *strcpy (char *str1, const char *str2){

 size_t  i;

  for(i=0; str2[i] != '\0'; i++)
    str1[i] = str2[i];

  str1[i] = '\0';
  return str1;
}

