#
#
#
#  Resea (/dec.mk)
#  Mafice <mafice@mflabo.net>
#
#
#



TMP_DIR          = /tmp
KERNEL_DIR       = $(SRC_TOP)/kernel
TOOLS_DIR        = $(SRC_TOP)/tools

CORE_BIN         = $(KERNEL_DIR)/core.bin
BOOT_BIN         = $(KERNEL_DIR)/boot.bin
KERNEL_BIN       = $(KERNEL_DIR)/kernel.bin
DISKIMG_FILENAME = $(SRC_TOP)/resea.img

DISKIMG_FILESIZE    = 2097152     # 2MB  (0x200000)
KERNEL_BIN_FILESIZE = 65536       # 64KB (0x10000)

AS          = nasm
CC          = gcc
LINK        = ld
MKSLIB      = ar crs
DELETE      = -rm
ECHO        = echo
ELF2BIN     = strip -Obinary
EMU         = $(TOOLS_DIR)/qemu-system-x86_64
ADDPADDING  = $(TOOLS_DIR)/addpadding.pl


EMU_OPTIONS  = -hda $(DISKIMG_FILENAME) -k ja -m 128 -localtime \
               -d cpu_reset -L /usr/share/qemu                  \
               -net nic,model=ne2k_pci -net user -net dump,file=/tmp/net_dump -redir tcp:12345:10.0.2.15:80

ASMBIN_FLAGS = -f bin   -s -I $(INCLUDE_DIR)/

ASMOBJ_FLAGS = -f elf64 -s -I $(INCLUDE_DIR)/

CFLAGS       = -c -std=c99 -m64 -Os -pipe                       \
               -Wall -Wunused -Wcast-qual  -Wcast-align         \
               -Winit-self                                      \
               -Wunsafe-loop-optimizations                      \
               -Wmissing-include-dirs -Wunknown-pragmas         \
               -fno-common -fno-builtin -fno-builtin-function   \
               -fno-stack-protector -mno-red-zone               \
               -nostdlib -mcmodel=large -mno-red-zone -mno-mmx  \
               -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow

LINKFLAGS    = -nostdlib -nodefaultlibs

ARFLAGS      = crs


%.bin: %.asm 
	$(ECHO) "  $*.bin"
	$(AS) $(ASMBIN_FLAGS) $< -o $@

%.obj: %.asm
	$(ECHO) "  $*.obj"
	$(AS) $(ASMOBJ_FLAGS) $< -o $@

%.o: %.c
	$(ECHO) "  $*.o"
	$(CC) $(CFLAGS) $< -o $@


