;
;
;
;    Resea (x86/boot1.asm)
;    Mafice <mafice@mflabo.net>
;
;
;

[bits 16]



;
;  レジスタ初期化
;

mov  ax, 0x800
mov  ds, ax
mov  ax, 0
mov  ss, ax



;
;  画面モードを設定
;

mov  ah, 0x00
mov  al, 0x03
int  0x10




;
;  A20有効化
;

call  waitKeyboard
mov   al,   0xd1
out   0x64, al
call  waitKeyboard
mov   al,   0xdf
out   0x60, al




;
;  プロテクトモードへ移行
;

mov     eax, cr0
or      eax, 0x00000001  ;プロテクトモード
mov     cr0, eax


;GDTを読み込む
loadGDT:
lgdt    [GDTR]


;boot2に移行
jmp dword 8:0x8400




;------------------------------------





halt:
hlt
jmp halt



print:
push ax
push bx
mov  ah, 0x0e
mov  bh, 0
mov  bl, 15

.loop:
mov  al, [si]
cmp  al, 0
je   .ret
int  0x10
inc  si
jmp  .loop

.ret:
pop  bx
pop  ax
ret



waitKeyboard:
in      al, 0x64
and     al, 0x02
in      al, 0x60
jnz     waitKeyboard
ret



align 8

GDTR:
dw   3*8 - 1
dq   GDT+0x8000

align 8


GDT:
dw 0x0000, 0x0000, 0x0000, 0x00
dw 0xffff, 0x0000, 0x9a00, 0xcf
dw 0xffff, 0x0000, 0x9200, 0x8f


times 0x400-($-$$) db 0

